﻿Public Class IconSlot
    Private drums(2) As drum        'スロットに使うドラム
    Private GamePoint As Long = 50  '最初の持ち点
    Const FIRST_MESSAGE As String = "Start with "
    Const GAME_OVER As String = "Game Over"
    Private MaxGamePoint As Integer

    Private Sub IconSlot_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        My.Settings.MaxPt = MaxGamePoint
        My.Settings.Save()

        For i As Integer = 0 To drums.Length - 1
            drums(i).Dispose()
        Next

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call SetDrums()
        Me.LabelMessage.Text = FIRST_MESSAGE & GamePoint.ToString & " pt"

        MaxGamePoint = My.Settings.MaxPt

        Me.ToolStripStatusLabel1.Text = String.Format("Max: {0}pt", MaxGamePoint.ToString)

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStart.Click
        If GamePoint <= 0 Then Exit Sub
        System.Media.SystemSounds.Beep.Play()

        Me.ButtonStart.Enabled = False

        For i As Integer = 0 To drums.Length - 1
            With drums(i)
                .PicBoxes(2).BorderStyle = Windows.Forms.BorderStyle.None
                .StopFlg = False
                .Timer1.Interval = 120 - i * 40
                .Timer1.Enabled = True

                For j As Integer = 0 To .PicBoxes.Length - 1
                    .PicBoxes(j).BackColor = Color.Aquamarine
                Next

            End With
        Next
        Me.LabelMessage.Text = "" : Me.LabelMessage.Text = String.Format("{0}pt", GamePoint.ToString)

        Me.ButtonDrumsChange.Enabled = False
        Me.PanelDrums.Focus()
        Do
            If drums(0).Timer1.Enabled = False And drums(1).Timer1.Enabled = False And drums(2).Timer1.Enabled = False Then

                Dim hanteiNumber As Integer = hantei(drums)
                Select Case hanteiNumber    '今回の仕様では同一のアイコンが３つ並ぶ列の最大値は３　
                    Case 0
                        GamePoint -= 5
                        If GamePoint < 5 Then
                            Me.LabelMessage.Text = GAME_OVER
                            Me.ButtonReTry.Enabled = True

                        Else
                            Me.LabelMessage.Text = String.Format("Miss!! 5pt down: {0}pt", GamePoint.ToString)
                        End If

                    Case 1
                        GamePoint += 20
                        Me.LabelMessage.Text = String.Format("Good!! 20pt up: {0}pt", GamePoint.ToString)
                        System.Media.SystemSounds.Exclamation.Play()

                    Case 2
                        GamePoint += 200
                        Me.LabelMessage.Text = String.Format("Very Good!! 200pt up: {0}pt", GamePoint.ToString)
                        System.Media.SystemSounds.Exclamation.Play()

                    Case 3
                        GamePoint += 2000
                        Me.LabelMessage.Text = String.Format("Greatest!! 2000pt up: {0}pt", GamePoint.ToString)
                        System.Media.SystemSounds.Exclamation.Play()
                End Select

                If GamePoint > MaxGamePoint Then
                    MaxGamePoint = GamePoint
                    Me.LabelMessage.Text = String.Format("Max Point Updated: {0}pt", GamePoint.ToString)
                    Me.ToolStripStatusLabel1.Text = String.Format("Max: {0}pt", MaxGamePoint.ToString)
                End If


                Me.ButtonStart.Enabled = True
                Exit Do
            End If
            Application.DoEvents()
        Loop

        Me.ButtonDrumsChange.Enabled = True
    End Sub

    Private Function hantei(ByVal dr() As drum) As Integer
        'アイコンが３つ並べば「当たり」
        Dim num As Integer = 0

        If dr(0).PicBoxes(1).Tag = dr(1).PicBoxes(1).Tag And dr(1).PicBoxes(1).Tag = dr(2).PicBoxes(1).Tag Then
            '下一列
            num += 1
            For i As Integer = 0 To dr.Length - 1
                dr(i).PicBoxes(1).BackColor = Color.Orange
            Next

        End If

        If dr(0).PicBoxes(2).Tag = dr(1).PicBoxes(2).Tag And dr(1).PicBoxes(2).Tag = dr(2).PicBoxes(2).Tag Then
            '中一列
            num += 1
            For i As Integer = 0 To dr.Length - 1
                dr(i).PicBoxes(2).BackColor = Color.Orange
            Next
        End If

        If dr(0).PicBoxes(3).Tag = dr(1).PicBoxes(3).Tag And dr(1).PicBoxes(3).Tag = dr(2).PicBoxes(3).Tag Then
            '上一列
            num += 1
            For i As Integer = 0 To dr.Length - 1
                dr(i).PicBoxes(3).BackColor = Color.Orange
            Next
        End If

        If dr(0).PicBoxes(3).Tag = dr(1).PicBoxes(2).Tag And dr(1).PicBoxes(2).Tag = dr(2).PicBoxes(1).Tag Then
            '斜め右下
            num += 1
            For i As Integer = 0 To dr.Length - 1
                dr(i).PicBoxes(3 - i).BackColor = Color.Orange
            Next
        End If

        If dr(0).PicBoxes(1).Tag = dr(1).PicBoxes(2).Tag And dr(1).PicBoxes(2).Tag = dr(2).PicBoxes(3).Tag Then
            '斜め右上
            num += 1
            For i As Integer = 0 To dr.Length - 1
                dr(i).PicBoxes(i + 1).BackColor = Color.Orange
            Next
        End If
        Return num

    End Function

    Private Sub SetDrums()

        For i As Integer = 0 To drums.Length - 1
            drums(i) = New drum
            Me.PanelDrums.Controls.Add(drums(i))
            drums(i).Left = i * 50
        Next
    End Sub

    Private Sub ButtonDrumsChange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDrumsChange.Click
        If Me.LabelMessage.Text = GAME_OVER Then Exit Sub

        If GamePoint <= 10 Then
            Me.LabelMessage.Text = String.Format("Can't Change: {0}pt", GamePoint.ToString)
            Exit Sub
        End If

        Me.PanelDrums.Controls.Clear()
        GamePoint -= 10
        Me.LabelMessage.Text = String.Format("Drums Changed: {0}pt", GamePoint.ToString)
        System.Media.SystemSounds.Asterisk.Play()
        Call SetDrums()

    End Sub

    Private Sub ButtonReTry_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReTry.Click
        GamePoint = 50
        Me.LabelMessage.Text = FIRST_MESSAGE & GamePoint.ToString & " pt"
        System.Media.SystemSounds.Asterisk.Play()
        Me.ButtonReTry.Enabled = False

    End Sub
End Class
